#include <bits/stdc++.h>
#define ll long long
#define MAXN 200010
using namespace std;
vector<ll> G[MAXN];
ll sum[MAXN],dp[MAXN],a[MAXN],res=LLONG_MAX,ind;
void DFS_Pocetak(ll i,ll p)
{
    sum[i]=a[i];
    for (ll next : G[i])
    {
        if (next!=p)
        {
            DFS_Pocetak(next,i);
            sum[i]+=sum[next];
            dp[i]+=dp[next]+sum[next];
        }
    }
}
void DFS(ll i,ll p,ll cur)
{
    if (cur<res)
    {
        res=cur;
        ind=i;
    }
    else if (cur==res)
        ind=min(i,ind);
    for (ll next : G[i])
    {
        if (next!=p)
            DFS(next,i,cur+sum[1]-2*sum[next]);
    }
}
int main()
{
    ios::sync_with_stdio(false); cin.tie(0); cout.tie(0);
    ll n,x,y,q;
    cin >> n;
    for (ll i=1;i<n;i++)
    {
        cin >> x >> y;
        G[x].push_back(y);
        G[y].push_back(x);
    }
    for (ll i=1;i<=n;i++)
        cin >> a[i];
    cin >> q;
    if (!q)
    {
        DFS_Pocetak(1,1);
        DFS(1,1,dp[1]);
        cout << ind << "\n";
        return 0;
    }
    return 0;
}